/*
   FNT - SQL-backend for SQLite3 - function disconnect

   Copyright (C) 2009 Free Software Foundation, Inc.

   Written by:
   Slava Zanko <slavazanko@gmail.com>


   This file is part of the FIDO New Technology.

   FIDO New Technology is free software: you can redistribute it and/or 
   modify it under the terms of the GNU General Public License as published 
   by the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifdef HAVE_CONFIG_H
#	include <config.h>
#endif

#include <sqlite3.h>
#include <stdlib.h>

#include "../include/global.h"

#include "../include/types.h"
#include "../include/error.h"
#include "../include/plugin.h"
#include "../include/sql.h"

#include "main.h"

/*** global variables **************************************************/

/*** file scope macro definitions **************************************/

/*** file scope type declarations **************************************/

/*** file scope variables **********************************************/

/*** file scope functions **********************************************/

/*** public functions **************************************************/

DLLEXPORT bool
disconnect (fnt_sql_connect_t ** _sql_connect)
{
    fnt_sql_connect_t *sql_connect;
    sqlite3_stmt *pStmt;

    if (_sql_connect == NULL || *_sql_connect == NULL)
	return false;

    sql_connect = *_sql_connect;

    sqlite3_close ((sqlite3 *) sql_connect->db_handle);

    g_free (sql_connect->info->local_db_path);
    g_free (sql_connect->info->db_name);
    g_free (sql_connect->info->host_name);
    g_free (sql_connect->info->user_name);
    g_free (sql_connect->info->password);
    g_free (sql_connect->info);
    g_free (sql_connect);
    *_sql_connect = NULL;

    return true;

}
